: <<serial.f>> ;
CREATE COMMTIMEOUTS $14 ALLOT
CREATE DCB $1C ALLOT

2 kernel32 WINAPI: GetCommTimeouts
2 kernel32 WINAPI: GetCommState
2 kernel32 WINAPI: SetCommTimeouts
2 kernel32 WINAPI: SetCommState
7 kernel32 WINAPI: CreateFileA
1 kernel32 WINAPI: CloseHandle
5 kernel32 WINAPI: WriteFile
5 kernel32 WINAPI: ReadFile

VARIABLE COM1

: OPENCOM1  ( -- ) 
  Z" COM1"
  C0000000         \ GENERIC_READ + GENERIC_WRITE
  0
  0
  $3               \ OPEN_EXISTING
  $80              \ FILE_ATTRIBUTE_NORMAL
  0
  CreateFileA COM1 !
;

: CLOSECOM1 ( -- )
  COM1 @ CloseHandle DROP 
;

: !BUADRATE ( buadrate -- )
  DCB CELL+ !
;
  
: !COMFLAG  ( flag -- )
  DCB CELL+ CELL+ !
;

: !READINTERVALTIMEOUT 
  COMMTIMEOUTS !
;

VARIABLE BUFCOM
VARIABLE READBYTE
VARIABLE WRITEBYTE

: COMMLOOPTEST
 ." Type any key" CR
 BEGIN 
   KEY
   DUP ." Write to Com:" . CR
   DUP BUFCOM !
   COM1 @ BUFCOM 4 READBYTE 0 WriteFile DROP 
   
   0 BUFCOM !
   COM1 @ BUFCOM 4 WRITEBYTE 0 ReadFile DROP
   BUFCOM @ ." Read From Com:" . CR

   $1B =               \ escape to quit
 UNTIL 
;

: testcom
OPENCOM1 

COM1 @ COMMTIMEOUTS GetCommTimeouts DROP
$400  !READINTERVALTIMEOUT          \ 100ms
COM1 @ DCB SetCommTimeouts DROP

COM1 @ DCB GetCommState DROP
$9600 !BUADRATE   
$1012 !COMFLAG                     \ no hardware flow control
COM1 @ DCB SetCommState DROP

COMMLOOPTEST

CLOSECOM1
;

